#!/usr/bin/python

# Takes queries of the form "/somebase-invoking-cgi/<authid>/*auth1/*auth2.."
# *auth2, etc is ignored - this script does NOT do lookahead
# Ignores all query parameters too!
# Looks for xri data in ../xri/<authid>/*auth1 et al


import sys
import os
import cgitb
import stat
import time

cgitb.enable()

indent="    "
indent2=indent*2
xrds=0
if (os.environ.has_key("HTTP_ACCEPT")):
    accept=os.environ["HTTP_ACCEPT"]
    acceptlines=accept.split(",")
    for acceptline in acceptlines:
       if acceptline.find('application/xrds+xml')==0:
            xrds=1
            break
 
if xrds:
     print "Content-Type: application/xrds+xml"
else:
     print "Content-Type: text/plain"
print

print '''<XRDS xmlns="xri://$xrds">'''
print indent+'''<XRD xmlns="xri://$xrd*($v*2.0)" version="2.0">'''


path=os.environ["PATH_INFO"]
parts=path.lower().split("/")
firstslash=parts[2].find("*",1)
firstbang=parts[2].find("!",1)

if (firstslash == -1) and (firstbang == -1):
	firstauth=parts[2]
elif (firstslash==-1):
	firstauth=parts[2][0:firstbang]
elif (firstbang==-1):
	firstauth=parts[2][0:firstslash]
elif (firstbang < firstslash):
	firstauth=parts[2][0:firstbang]
else:
	firstauth=parts[2][0:firstslash]
print indent2+"<Query>"+firstauth+"</Query>"
query=parts[1]+"/"+firstauth
try:
     infile=open("../xri/"+query)
except IOError:
     status="222"
else:
     status="100"
     
print indent2+'''<Status code="'''+status+'''"/>'''

if (status == "100"):
     mtime=os.stat("../xri/"+query)[stat.ST_MTIME]
     etime=mtime+(86400*7) # Keep for a week
     if etime < time.time(): # If the etime based on file mtime is past
	etime=time.time()+3600 # Just keep for an hour from now? 
     print indent2+'''<Expires>'''+time.strftime("%Y-%m-%dT%H:%M:%SZ",time.gmtime(etime))+"</Expires>"

print indent2+'''<ProviderID>'''+parts[1]+'''</ProviderID>'''

if (status =="100"):
     for line in infile.readlines():
         print indent2+line,

print indent+'''</XRD>\n</XRDS>'''


